'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _container = require('./container');

var _container2 = _interopRequireDefault(_container);

var _context = require('../context');

var _context2 = _interopRequireDefault(_context);

var _utils = require('../utils');

var _global = require('./global');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ArrayContainer = function (_Container) {
    _inherits(ArrayContainer, _Container);

    function ArrayContainer(args) {
        _classCallCheck(this, ArrayContainer);

        var _this = _possibleConstructorReturn(this, (ArrayContainer.__proto__ || Object.getPrototypeOf(ArrayContainer)).call(this, args));

        _this.template = args.children;
        _this.state = { children: {} };
        return _this;
    }

    _createClass(ArrayContainer, [{
        key: 'getValue',
        value: function getValue() {
            return (0, _utils.toArray)(this.inputs).map(function (input) {
                return input.getValue();
            });
        }
    }, {
        key: 'setValues',
        value: function setValues(values) {
            var _this2 = this;

            if (!(values instanceof Array)) {
                throw new Error('Expecting array of values for ' + this.props.name);
            }

            var inputs = (0, _utils.toArray)(this.inputs);

            for (var i = 0; i < values.length - inputs.length; ++i) {
                this.addBlock();
            }

            setTimeout(function () {
                inputs = (0, _utils.toArray)(_this2.inputs);
                for (var _i = 0; _i < values.length; ++_i) {
                    inputs[_i].setValues(values[_i]);
                }
            });
        }
    }, {
        key: 'clone',
        value: function clone(children, id) {
            var _this3 = this;

            return _react2.default.Children.map(children, function (child) {
                var props = {};
                var children = [];
                for (var i in child.props) {
                    props[i] = child.props[i];
                    if (typeof child.props[i] === 'function') {
                        props[i] = (0, _global.scope)(child.props[i], id);
                    }
                    if (i === 'children' && _typeof(props[i]) === 'object') {
                        props[i] = _this3.clone(props[i], id);
                    }
                }

                return _react2.default.cloneElement(child, props);
            });
        }
    }, {
        key: 'removeBlock',
        value: function removeBlock(id) {
            var children = this.state.children;
            delete children[id];

            this.setState({ children: children });
        }
    }, {
        key: 'addBlock',
        value: function addBlock() {
            var children = this.state.children;
            var id = (0, _utils.Random)();

            children[id] = _react2.default.createElement(_container2.default, { key: id, id: id, children: this.clone(this.template, id), name: this.id + "_" + id });

            this.setState({ children: children });
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _utils.Stateless,
                { className: 'reform container repetitive' },
                (0, _utils.toArray)(this.state.children)
            );
        }
    }]);

    return ArrayContainer;
}(_container2.default);

ArrayContainer.propTypes = {
    id: _react2.default.PropTypes.string.isRequired
};

ArrayContainer.clone = function (name) {
    if (arguments.length > 1) {
        name = arguments[1];
    }
    try {
        (0, _global.get)(name).addBlock();
    } catch (e) {
        return currentScope.findElement(name).addBlock();
    }
};

ArrayContainer.remove = function (ev) {
    (0, _global.getCurrentScope)().parent.removeBlock((0, _global.getCurrentScope)().id);
};

exports.default = ArrayContainer;