"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.register = register;
exports.get = get;
exports.getCurrentScope = getCurrentScope;
exports.scope = scope;
var instances = {};

function register(cont) {
    if (instances[cont.id]) {
        throw new Error("Container with id=" + cont.id + " already exists in the document");
    }
    instances[cont.id] = cont;
}

function get(id) {
    if (!instances[id]) {
        throw new Error("Cannot find container " + id);
    }
    return instances[id];
}

var currentScope = void 0;

function getCurrentScope() {
    if (!currentScope) {
        throw new RuntimeException("Block.remove() is called outside of its scope");
    }
    return currentScope;
}

function scope(callback, scope) {
    return function () {
        currentScope = get(scope);
        callback();
        currentScope = null;
    };
}