'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Random = Random;
exports.toArray = toArray;
exports.Stateless = Stateless;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Random() {
    var length = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 10;

    return Math.random().toString(36).substr(2, length);
}

function toArray(object) {
    var values = [];
    for (var name in object) {
        if (object.hasOwnProperty(name)) {
            values.push(object[name]);
        }
    }
    return values;
}

function Stateless(props) {
    if (!props.children) {
        return null;
    } else if (_react2.default.isValidElement(props.children)) {
        return props.children;
    }
    return _react2.default.createElement(
        'div',
        props,
        props.children
    );
}